//+------------------------------------------------------------------+
//|                                                     BarRange.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Nikolaj Ostapjuk"
#property link      "nikost@inbox.lv"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Blue
extern int period=5;
extern int n=3;
extern bool Filter=false;
extern bool Allert=false;
extern int CountBars=5555;
//----
int pre_signal = 0;
//----
double Ddir1[];
double Ddir2[];
double Ddir3[];
//-----------------------------------------------+
int init()
  {
   IndicatorBuffers(3);
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,Ddir3);
   SetIndexBuffer(1,Ddir1);
   SetIndexBuffer(2,Ddir2);
   SetIndexDrawBegin(0,Bars-CountBars);
   return(0);
  }
//-------------------------------------------------+
int deinit()
  {
   return(0);
  }
//--------------------------------------------------+
int start()
 {
    double close, close1,filter,delta;
    int i,counted_bars=IndicatorCounted();

    i=Bars-counted_bars -1;
    int limit1 =Bars-counted_bars;
    if (limit1>1)
     {
      limit1 = Bars-1;
     }
  for (i=limit1;i>=0;i--)
    {
    int x=0;
    int y=0;
    if(Filter)
    filter=MathAbs(iMA(NULL,0,period,0,0,PRICE_CLOSE,i)-iMA(NULL,0,period,0,0,PRICE_OPEN,i));
    else filter=0.0;
    delta=MathAbs(Close[i]-Open[i]);
    close=Close[i];
    close1=Close[i+1]; 
    if(delta<=filter || close==close1) Ddir3[i]=Ddir3[i+1];
    else
     {
      if (close>close1) x=1;  

         Ddir1 [i]=x;

      if (close<close1) y=-1; 
         Ddir2 [i]=y;
      if (Ddir1 [i] >0 && Ddir2 [i+1] < 0) Ddir3 [i] = 1;
      if (Ddir1 [i] >0 && Ddir1 [i+1] > 0) Ddir3 [i] = Ddir3 [i+1]+1;
      if (Ddir2 [i] <0 && Ddir1 [i+1] > 0) Ddir3 [i] = -1;
      if (Ddir2 [i] <0 && Ddir2 [i+1] < 0) Ddir3 [i] = Ddir3 [i+1]-1;
     }
     
   }
//-------------------------------------------------------------+
   if(Allert)
        {
             if(pre_signal <= 0 && Ddir3[i+1] >=n) 
               { 
                 Alert("Bar"," Up  ",Symbol()," ", Period());
                 pre_signal =  1; 
               }
             if(pre_signal >= 0 && Ddir3[i+1] <= -n) 
               { 
                 Alert("Bar"," Down ",Symbol()," ", Period());
                 pre_signal = -1; 
               }               
        }
  return(0);
}